/*
  f90_unix_file_const.c : Determine values of constants for f90_unix_file

   This file is part of Posix90

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA. 

*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

main(){

    printf("! DO NOT EDIT THIS FILE. \n");
    printf("! It is created from f90_unix_file_const.c\n");
    printf("integer, parameter :: f_ok = %d\n", F_OK);
    printf("integer, parameter :: r_ok = %d\n", R_OK);
    printf("integer, parameter :: W_ok = %d\n", W_OK);
    printf("integer, parameter :: X_ok = %d\n", X_OK);
    printf("integer, parameter :: S_IRGRP = %d\n", S_IRGRP);
    printf("integer, parameter :: S_IROTH = %d\n", S_IROTH);
    printf("integer, parameter :: S_IRUSR = %d\n", S_IRUSR);
    printf("integer, parameter :: S_IRWXG = %d\n", S_IRWXG);
    printf("integer, parameter :: S_IRWXO = %d\n", S_IRWXO);
    printf("integer, parameter :: S_IRWXU = %d\n", S_IRWXU);
    printf("integer, parameter :: S_ISGID = %d\n", S_ISGID);
    printf("integer, parameter :: S_ISUID = %d\n", S_ISUID);
    printf("integer, parameter :: S_IWGRP = %d\n", S_IWGRP);
    printf("integer, parameter :: S_IWOTH = %d\n", S_IWOTH);
    printf("integer, parameter :: S_IWUSR = %d\n", S_IWUSR);
    printf("integer, parameter :: S_IXGRP = %d\n", S_IXGRP);
    printf("integer, parameter :: S_IXOTH = %d\n", S_IXOTH);
    printf("integer, parameter :: S_IXUSR = %d\n", S_IXUSR);
    printf("integer, parameter :: dev_kind = %d\n", sizeof(dev_t));
    printf("integer, parameter :: ino_kind = %d\n", sizeof(ino_t));
    printf("integer, parameter :: off_kind = %d\n", sizeof(off_t));
    printf("integer, parameter :: nlink_kind = %d\n", sizeof(nlink_t));
    return 0;
}


